VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.ocx"
Begin VB.Form Form2 
   Caption         =   "Form2"
   ClientHeight    =   6765
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9735
   LinkTopic       =   "Form2"
   ScaleHeight     =   6765
   ScaleWidth      =   9735
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog File 
      Left            =   3480
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.ListBox lstID3V2Info 
      Height          =   3375
      Left            =   6720
      TabIndex        =   2
      Top             =   600
      Width           =   2535
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "Command1"
      Height          =   735
      Left            =   360
      TabIndex        =   1
      Top             =   600
      Width           =   1335
   End
   Begin VB.Label lblStatus 
      Caption         =   "Label1"
      Height          =   735
      Left            =   360
      TabIndex        =   0
      Top             =   1800
      Width           =   5535
   End
End
Attribute VB_Name = "Form2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Better Audio Manager - a better audio manager for the Nokia 5510
'Copyright (C) 2003  Doug McPherson - bam@mcpherson.id.au

'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
Private Sub cmdOpen_Click()
  Dim MP3FileName$, Mp3FileNumber, Mp3FileContent$
  Dim ID3position As Long, ID3Length$, lngID3Length As Long
  Dim ID3Version$, ID3V2Tag$
  
  On Error Resume Next
    
    'ffnen-Dialog
    'Open Dialog
    lstID3V2Info.Clear
    File.DefaultExt = ".MP3"
    File.DialogTitle = "MP3 Open"
    File.Filter = "MP3-Files|*.MP3"
    File.ShowOpen
    
    If Dir$(File.FileName) <> "" Then
      lblStatus.Caption = "MP3 Open..."
      
      MP3FileName$ = File.FileName
      Mp3FileNumber = FreeFile
      'MP3 einlesen...
      ' MP3 read in...
      Open MP3FileName$ For Binary As Mp3FileNumber
        lblStatus.Caption = "Please wait while the MP# is read..."
        Mp3FileContent$ = String$(LOF(Mp3FileNumber), "!")
      Get Mp3FileNumber, , Mp3FileContent$
      Close Mp3FileNumber
      
      'ID3V2-Tag suchen
      'search for ID3V2-Tag
      'lblStatus.Caption = "Bitte warten, suche ID3V2-Tag"
      lblStatus.Caption = "Please wait, searching for ID3V2-Tag"
      
      ID3position = InStr(Mp3FileContent$, "ID3")
      If ID3position = 0 Then
        lblStatus.Caption = "No ID3V2-Tag available" '"Kein ID3V2-Tag vorhanden"
        Exit Sub
      End If
      
      'Tag gefunden, weiter gehts!
      'Tag found, on we go!
      lblStatus.Caption = "ID3V2-Tag found!" '"ID3V2-Tag gefunden!"
      ID3Version$ = Mid$(Mp3FileContent$, ID3position + 3, 2)
      
      'Version Control
      If Asc(Left$(ID3Version$, 1)) <> 2 And _
        Asc(Left$(ID3Version$, 1)) <> 3 And _
        Asc(Left$(ID3Version$, 1)) <> 4 Then
          lblStatus.Caption = "Invalid Version! (" + _
                              Trim$(Str$(Asc(Left$(ID3Version$, _
                              1)))) + ")"
          Exit Sub
      End If
      
      'Show Version
      lstID3V2Info.AddItem "ID3V2-Version:" + _
                      Str$(Asc(Left$(ID3Version$, 1))) + "." + _
                      Trim$(Str$(Asc(Right$(ID3Version$, 1))))
                      
      'Lnge bestimmen
      'determine length
      ID3Length$ = Mid$(Mp3FileContent$, ID3position + 6, 4)
      lngID3Length = 256 * 8 * 8 * Asc(Left$(ID3Length$, 1)) + _
                     256 * 8 * Asc(Mid$(ID3Length$, 2, 1)) + _
                     256 * Asc(Mid$(ID3Length$, 3, 1)) + _
                     Asc(Mid$(ID3Length$, 4, 1))
      lstID3V2Info.AddItem "Length of ID3V2-Tags:" + _
                           Str$(lngID3Length) + " Byte"
                           
      ID3V2Tag$ = Mid$(Mp3FileContent$, ID3position, _
                       lngID3Length + 10)
                       
      Mp3FileContent$ = ""
      
      'Nach Extended Header suchen...
      'Look for Extended Header
      If Asc(Mid$(ID3V2Tag$, 6, 1)) Or 4 = True Then
        lstID3V2Info.AddItem "Extended Header found"
        ID3V2Tag$ = Mid$(ID3V2Tag$, 10)
      End If
      ID3V2Tag$ = Mid$(ID3V2Tag$, 11)
      
      'Nun Frame fr Frame abarbeiten...
      'Now Frame by Frame process...
      Dim FrameName$
      Dim FrameLen$, lngFrameLen
      Dim FrameFlags$, Frame$
      
      Do
        'ID3V2.3
        If Asc(Left$(ID3Version$, 1)) = 3 Or _
           Asc(Left$(ID3Version$, 1)) = 4 Then
          
          'Frame-Header auslesen
          'Pick out Frame headers
          FrameName$ = Left$(ID3V2Tag$, 4)
          
          'Wenn es sich um den Footer handelt, dann sind wir
          'fertig!
          ' if it around the Footer acts, then we are finished!
          If Left$(FrameName$, 3) = "3DI" Then Exit Do
          FrameLen$ = Mid$(ID3V2Tag$, 5, 4)
          lngFrameLen = 256 * 8 * 8 * Asc(Left$(FrameLen$, 1)) _
                        + 256 * 8 * Asc(Mid$(FrameLen$, 2, 1)) _
                        + 256 * Asc(Mid$(FrameLen$, 3, 1)) + _
                        Asc(Mid$(FrameLen$, 4, 1))
          
          FrameFlags$ = Mid$(ID3V2Tag$, 9, 2)
          ID3V2Tag$ = Mid$(ID3V2Tag$, 11)
          
          'Frame-Content bestimmen
          'Determine frame content
          Select Case FrameName$
            Case "PCNT": Frame$ = "Play Counter:"
            Case "TRCK": Frame$ = "Track:"
            Case "TENC": Frame$ = "Encoded by:"
            Case "WXXX": Frame$ = "Link:"
            Case "TCOP": Frame$ = "Copyright (c):"
            Case "TOPE": Frame$ = "Original Artist:"
            Case "TCOM": Frame$ = "Composer:"
            Case "TCON": Frame$ = "Genre:"
            Case "COMM": Frame$ = "Comment:"
            Case "TYER": Frame$ = "Year:"
            Case "TALB": Frame$ = "Album:"
            Case "TPE1": Frame$ = "Artist:"
            Case "TIT2": Frame$ = "Title:"
            Case "TLAN": Frame$ = "Language:"
            Case "TLEN": Frame$ = "Length:"
            Case "TMED": Frame$ = "Type of medium:"
            Case "TPUB": Frame$ = "Publisher:"
            Case "TSSE": Frame$ = "Decoding-Software:"
            Case Else:   Frame$ = "Unknown Frame(" + _
                                   FrameName$ + "):"
          End Select
          
          If Left$(ID3V2Tag$, 1) = Chr$(0) Then
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Mid$(ID3V2Tag$, 2, _
                                 lngFrameLen - 1)
          Else
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Left$(ID3V2Tag$, _
                                 lngFrameLen)
          End If
          
          ID3V2Tag$ = Mid$(ID3V2Tag$, lngFrameLen + 1)
        
        'ID3V2.2
        ElseIf Asc(Left$(ID3Version$, 1)) = 2 Then
          
          'Frame-Header auslesen
          FrameName$ = Left$(ID3V2Tag$, 3)
          
          'Wenn es sich um den Footer handelt, dann sind wir
          'fertig!
          If FrameName$ = "3DI" Then Exit Do
          FrameLen$ = Mid$(ID3V2Tag$, 4, 3)
          lngFrameLen = 256 * 8 * Asc(Left$(FrameLen$, 1)) + _
                        256 * Asc(Mid$(FrameLen$, 2, 1)) + _
                        Asc(Mid$(FrameLen$, 3, 1))
                        
          ID3V2Tag$ = Mid$(ID3V2Tag$, 7)
          
          'Frame-Content bestimmen
          Select Case FrameName$
            Case "TRK": Frame$ = "Track:"
            Case "TEN": Frame$ = "Encoded von:"
            Case "TCR": Frame$ = "Copyright (c):"
            Case "TOA": Frame$ = "Ursprnglicher Knstler:"
            Case "TCM": Frame$ = "Composer:"
            Case "TCO": Frame$ = "Genre:"
            Case "COM": Frame$ = "Kommentar:"
            Case "TYE": Frame$ = "Jahr:"
            Case "TAL": Frame$ = "Album:"
            Case "TP1": Frame$ = "Knstler:"
            Case "TT2": Frame$ = "Titel:"
            Case "TLA": Frame$ = "Sprache:"
            Case "TMT": Frame$ = "Medientyp:"
            Case "TSS": Frame$ = "Decoding-Software:"
            Case Else:  Frame$ = "Unbekanntes Frame(" + _
                                 FrameName$ + "):"
          End Select
          
          If Left$(ID3V2Tag$, 1) = Chr$(0) Then
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Mid$(ID3V2Tag$, _
                                 2, lngFrameLen - 1)
          Else
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Left$(ID3V2Tag$, _
                                 lngFrameLen)
          End If
          
          ID3V2Tag$ = Mid$(ID3V2Tag$, lngFrameLen + 1)
          
        End If
      Loop Until Len(ID3V2Tag$) = 0
      lblStatus.Caption = "Bereit!"
      
      'DMcP 16/1/03
      'Now do V1 stuff
      
      
      If ExtractID3(File.FileName).Tag = "TAG" Then
        lstID3V2Info.AddItem ""
        lstID3V2Info.AddItem "v1 Tags"
        
        lstID3V2Info.AddItem "Title: " + ExtractID3(File.FileName).Title
        lstID3V2Info.AddItem "Artist: " + ExtractID3(File.FileName).artist
        lstID3V2Info.AddItem "Album: " + ExtractID3(File.FileName).Album
        lstID3V2Info.AddItem "Year: " + ExtractID3(File.FileName).Year
        'lstID3V2Info.AddItem "Genre: " + GetGenre(Asc(ExtractID3(File.FileName).Genre))
        lstID3V2Info.AddItem "Notes: " + ExtractID3(File.FileName).Notes
      End If
     
Else
      
    End If
End Sub
 
Private Sub Form_Load()
  lblStatus.Caption = "Bitte eine MP3 ffnen"
End Sub
