Attribute VB_Name = "Module1"
'Better Audio Manager - a better audio manager for the Nokia 5510
'Copyright (C) 2003  Doug McPherson - bam@mcpherson.id.au

'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Option Explicit

Global gPercCopied
Global gCancelCopy

Public Declare Function GetDiskFreeSpace Lib "kernel32" _
Alias "GetDiskFreeSpaceA" _
(ByVal lpRootPathName As String, _
lpSectorsPerCluster As Long, _
lpBytesPerSector As Long, _
lpNumberOfFreeClusters As Long, _
lpTtoalNumberOfClusters As Long) As Long




Public Type ID3DataType
    Tag As String * 3
    Title As String * 30
    artist As String * 30
    Album As String * 30
    Year As String * 4
    Notes As String * 30
End Type
Public Function ExtractID3(MP3path As String) As ID3DataType
Dim MP3File As Integer

    MP3File = FreeFile
    Open MP3path For Binary As MP3File
    If LOF(MP3File) > 128 Then
        Get MP3File, LOF(MP3File) - 127, ExtractID3
    End If
    Close MP3File
End Function
Private Sub File1_Click()
End Sub
Public Function GetGenre(G As Integer) As String
GetGenre = "unknown"
Select Case G
Case 0
GetGenre = "Blues"
Case 1
GetGenre = "Classic Rock"
Case 2
GetGenre = "Country"
Case 3
GetGenre = "Dance"
Case 4
GetGenre = "Disco"
Case 5
GetGenre = "Funk"
Case 6
GetGenre = "Grunge"
Case 7
GetGenre = "Hip-Hop"
Case 8
GetGenre = "Jazz"
Case 9
GetGenre = "Metal"
Case 10
GetGenre = "New Age"
Case 11
GetGenre = "Oldies"
Case 12
GetGenre = "Other"
Case 13
GetGenre = "Pop"
Case 14
GetGenre = "R&B"
Case 15
GetGenre = "Rap"
Case 16
GetGenre = "Reggae"
Case 17
GetGenre = "Rock"
Case 18
GetGenre = "Techno"
Case 19
GetGenre = "Industrial"
Case 20
GetGenre = "Alternative"
Case 21
GetGenre = "Ska"
Case 22
GetGenre = "Death Metal"
Case 23
GetGenre = "Pranks"
Case 24
GetGenre = "Soundtrack"
Case 25
GetGenre = "Euro-Techno"
Case 26
GetGenre = "Ambient"
Case 27
GetGenre = "Trip-Hop"
Case 28
GetGenre = "Vocal"
Case 29
GetGenre = "Jazz+Funk"
Case 30
GetGenre = "Fusion"
Case 31
GetGenre = "Trance"
Case 32
GetGenre = "Classical"
Case 33
GetGenre = "Instrumental"
Case 34
GetGenre = "Acid"
Case 35
GetGenre = "House"
Case 36
GetGenre = "Game"
Case 37
GetGenre = "Sound Clip"
Case 38
GetGenre = "Gospel"
Case 39
GetGenre = "Noise"
Case 40
GetGenre = "AlternRock"
Case 41
GetGenre = "Bass"
Case 42
GetGenre = "Soul"
Case 43
GetGenre = "Punk"
Case 44
GetGenre = "Space"
Case 45
GetGenre = "Meditative"
Case 46
GetGenre = "Instrumental Pop"
Case 47
GetGenre = "Instrumental Rock"
Case 48
GetGenre = "Ethnic"
Case 49
GetGenre = "Gothic"
Case 50
GetGenre = "Darkwave"
Case 51
GetGenre = "Techno-Industrial"
Case 52
GetGenre = "Electronic"
Case 53
GetGenre = "Pop-Folk"
Case 54
GetGenre = "Eurodance"
Case 55
GetGenre = "Dream"
Case 56
GetGenre = "Southern Rock"
Case 57
GetGenre = "Comedy"
Case 58
GetGenre = "Cult"
Case 59
GetGenre = "Gangsta"
Case 60
GetGenre = "Top 40"
Case 61
GetGenre = "Christian Rap"
Case 62
GetGenre = "Pop/Funk"
Case 63
GetGenre = "Jungle"
Case 64
GetGenre = "Native American"
Case 65
GetGenre = "Cabaret"
Case 66
GetGenre = "New Wave"
Case 67
GetGenre = "Psychadelic"
Case 68
GetGenre = "Rave"
Case 69
GetGenre = "Showtunes"
Case 70
GetGenre = "Trailer"
Case 71
GetGenre = "Lo-Fi"
Case 72
GetGenre = "Tribal"
Case 73
GetGenre = "Acid Punk"
Case 74
GetGenre = "Acid Jazz"
Case 75
GetGenre = "Polka"
Case 76
GetGenre = "Retro"
Case 77
GetGenre = "Musical"
Case 78
GetGenre = "Rock & Roll"
Case 79
GetGenre = "Hard Rock"
End Select
End Function
Function FreeSpace(drive As String) As Double
    Dim SectorsPerCluster As Long
    Dim BytesPerSector As Long
    Dim NumberOfFreeClusters As Long
    Dim TotalNumberOfClusters As Long
    Dim BytesTotal As Double
    Dim BytesAvailable As Double
    
    Call GetDiskFreeSpace(drive, _
                        SectorsPerCluster, _
                        BytesPerSector, _
                        NumberOfFreeClusters, _
                        TotalNumberOfClusters)
    BytesTotal = (BytesPerSector * SectorsPerCluster * CDbl(TotalNumberOfClusters))
    BytesAvailable = (BytesPerSector * SectorsPerCluster * CDbl(NumberOfFreeClusters))
    
    'Debug.Print "BytesTotal = " & BytesTotal
    'Debug.Print "BytesAvailable = " & BytesAvailable
    FreeSpace = BytesAvailable
        
End Function



Sub windowpos(Window As Form)
Dim sw As Single
Dim ww As Single

    DoEvents
    sw = frmMain.Width
    ww = Window.Width
    If (Abs(sw) > 32000) Or (Abs(ww) > 32000) Or (Abs(sw - ww) > 32000) Then MsgBox "Overflow in WindowPos", vbOK
    Window.Left = (sw - ww) / 2 + frmMain.Left ' Center form horizontally.
    Window.Top = (frmMain.Height - Window.Height) / 2 + frmMain.Top ' Center form vertically.
End Sub

